﻿#pragma once
#include <stddef.h>
#define PAGE_BYTES 0x2000LL                                     // 一页字节
#define CLASS_TOTAL_BYTES 0x4000                                // class预先申请大小标准
#define CLASS_MAX_BYTES 0x40000                                 // class 最大字节数
#define MAX_CLASS_COUNT  8					                    // 最多预先初始化几个内存				  

#define MAX_SHM_BLOCK_COUNT 0xff                                 
#define AREA_SIZE 0x20000LL                                

#define BYTES_TO_PAGES(bytes)    ((bytes) >> 13)
#define PAGES_TO_BYTES(page)    ((page) << 13)

#define PALIGN_DOWN(x, align) ((x) & ~((align) - 1))
#define PALIGN_UP(x, align) (((x) + ((align) - 1)) & (~((align) - 1)))

namespace bg
{
    namespace detail
    {
        namespace ShmConfig
        {
            constexpr size_t MAX_PAGE_COUNT = 0x7FFFFFFFFLL;
        }
    }


}